% compute the negative log likelihood and its gradient

function [f, df] = CG_MNIST(VV,Dim,XX, target);
    % recover the parameters
    l1=Dim(1);  % number of input features, not including the bias
    l2=1;       % number of output features
    
    w1 = reshape(VV(1:(l1+1)*l2),l1+1,l2);
    m=XX * w1;
    f=target' * m - sum(log(1+exp(m)));
    f = -f; % negative log likelihood
    
    % derivative of the objective function w.r.t. m
    out=1./(1+exp(-m));
    delta=target-out;
    df=XX' * delta;
    df=-df;